<#ibizinclude>
../../../@MACRO/LANG_FUN.ftl
</#ibizinclude>
<#--  后台界面行为  -->
<#if backend_block??>
${backend_block}
<#else>
    /**
     * ${item.getCaption()}
     *
     * @param {any[]} args 当前数据
     * @param {any} context 行为附加上下文
     * @param {*} [params] 附加参数
     * @param {*} [$event] 事件源
     * @param {*} [xData]  执行行为所需当前部件
     * @param {*} [actionContext]  执行行为上下文
     * @param {*} [srfParentDeName] 父实体名称
     * @returns {Promise<any>}
    <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()??>
     * @memberof ${srfclassname('${item.getPSAppDataEntity().getCodeName()}')}UIService
    </#if>
     */
    public async ${item.getFullCodeName()}(args: any[],context:any = {}, params:any = {}, $event?: any, xData?: any,actionContext?: any,srfParentDeName?:string){
    <#if item.render??>
        ${item.render.code}
    <#else>
        <#if item.getUILogicAttachMode?? && item.getUILogicAttachMode()?? && item.getUILogicAttachMode() == 'REPLACE' && item.getPSAppDEUILogic?? && item.getPSAppDEUILogic()??>
        const _context: any = Object.assign(context, actionContext.context);
        const _params: any = Object.assign(params, actionContext.viewparams);
            <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()?? && item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()?? && item.getPSAppDataEntity().codeName == item.getPSAppDEUILogic().getPSAppDataEntity().codeName>
        return this.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
            <#elseif item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()??>
        const uiService = await window.uiServiceRegister.getService('${item.getPSAppDEUILogic().getPSAppDataEntity().codeName}');
        return uiService.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
            </#if>
        <#else>
        <#--  BEGIN: 自定义确认  -->
            <#if item.getEnableConfirm?? && item.getEnableConfirm() && item.getConfirmMsg?? && item.getConfirmMsg()??>
        let confirmResult:boolean = await new Promise((resolve: any, reject: any) => {
          actionContext.$Modal.confirm({
              title: '警告',
              content: '${item.getConfirmMsg()}',
              onOk: () => {resolve(true);},
              onCancel: () => {resolve(false);}
          });
        });
        if(!confirmResult){
            return;
        }
            </#if>
        <#--  END: 自定义确认  -->
            <#if item.getActionTarget() == 'MULTIDATA'>
        actionContext.$Notice.error({ title: '错误', desc: '不支持多项数据' });
            <#else>
        let data: any = {};
        let tempData: any = {};
        let tempContext: any = {};
        let tempViewParam: any = {};
        const _this: any = actionContext;
        <#-- 是否先保存目标数据start -->
                <#if item.isSaveTargetFirst()>
        const result:any = await xData.save(args,false);
                    <#if item.getActionTarget() == 'SINGLEDATA'>
        Object.assign(args[0], result.data);
                    <#else>
        args = [result.data];
                    </#if>
                </#if>
         <#-- 是否先保存目标数据end -->
        const _args: any[] = Util.deepCopy(args);
        const actionTarget: string | null = <#if item.getActionTarget()??>'${item.getActionTarget()}'<#else>null</#if>;
                <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()??>
                    <#assign appDataEntity = item.getPSAppDataEntity() />
                    <#if item.getActionTarget() == 'SINGLEKEY' || item.getActionTarget() == 'MULTIKEY'>
                        <#assign valueItem><#if item.getValueItem?? && item.getValueItem() != ''>${item.getValueItem()}<#else>${appDataEntity.getKeyPSAppDEField().getCodeName()?lower_case}</#if></#assign>
                        <#assign paramItem><#if item.getParamItem?? && item.getParamItem() != ''>${item.getParamItem()}<#else>${appDataEntity.getCodeName()?lower_case}</#if></#assign>
                        <#assign textItem><#if item.getTextItem?? && item.getTextItem() != ''>${item.getTextItem()}<#else>${appDataEntity.getMajorPSAppDEField().getCodeName()?lower_case}</#if></#assign>
        if (_args && args[0] && args[0]['${valueItem}']) {
            Object.assign(tempContext, { ${appDataEntity.codeName?lower_case}: '%${valueItem}%' });
        } else {
            Object.assign(tempContext, { ${appDataEntity.codeName?lower_case}: '%${paramItem}%' });
        }
        Object.assign(tempViewParam, { ${valueItem}: '%${paramItem}%' });
        Object.assign(tempViewParam, { ${textItem}: '%${textItem}%' });
                    </#if>
                </#if>
                <#if item.getPSNavigateContexts?? && item.getPSNavigateContexts()??>
        Object.assign(tempContext, <@getNavigateContext item />);
                </#if>
                <#if item.getPSNavigateParams?? && item.getPSNavigateParams()??>
        Object.assign(tempViewParam, <@getNavigateParams item />);
                </#if>
        tempContext = UIActionTool.handleContextParam(actionTarget, _args, context, params, tempContext);
                <#if item.getActionTarget() == 'SINGLEDATA'>
        tempData = UIActionTool.handleActionParam(actionTarget, _args, context, params, tempViewParam);
        Object.assign(data, tempData);
                <#else>
        data = UIActionTool.handleActionParam(actionTarget, _args, context, params, tempViewParam);
                </#if>
        <#-- 多项数据主键转换数据 start -->
        if (Object.is(actionTarget, "MULTIKEY")) {
            let tempDataArray:Array<any> = [];
            if ((_args.length > 1) && (Object.keys(data).length > 0)) {
                for(let i =0; i < _args.length; i++){
                    let tempObject: any = {};
                    Object.keys(data).forEach((key:string) =>{
                        Object.assign(tempObject,{ [key]: data[key].split(',')[i] });
                    })
                    tempDataArray.push(tempObject);
                }
            } else {
                tempDataArray.push(data);
            }
            data = tempDataArray;
        }
        <#-- 多项数据主键转换数据 end -->
        Object.assign(context, tempContext);
        <#-- 构建srfparentdename和srfparentkey start -->
        let parentObj: any = {
            srfparentdename: srfParentDeName ? srfParentDeName : null,
            srfparentkey: srfParentDeName ? context[srfParentDeName.toLowerCase()] : null
        };
        <#-- 多项数据主键转换数据 start -->
        if(!Object.is(actionTarget,"MULTIKEY")){
            Object.assign(data, parentObj);
        }
        <#-- 多项数据主键转换数据 end -->
        Object.assign(context, parentObj);
        <#-- 构建srfparentdename和srfparentkey end -->
        // 直接调实体服务需要转换的数据
        if(context && context.srfsessionid){
            context.srfsessionkey = context.srfsessionid;
            delete context.srfsessionid;
        }
        const backend = () => {
            if (xData && xData.formValidateStatus instanceof Function) {
                if (!xData.formValidateStatus()) {
                    actionContext.$Notice.error({ title: '错误', desc: actionContext.$t('app.searchform.globalerrortip') as string });
                    return;
                }
            }
                <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()?? && item.getPSAppDEMethod?? && item.getPSAppDEMethod()??>
            const curService: ${srfclassname('${item.getPSAppDataEntity().getCodeName()}')}Service =  new ${srfclassname('${item.getPSAppDataEntity().getCodeName()}')}Service();
                    <#if item.getActionTarget() == 'MULTIKEY'>
            const promiseArray: any[] = [];
            if (data && data.length > 0) {
                const srfkeys = context['${item.getPSAppDataEntity().codeName?lower_case}'] ? context['${item.getPSAppDataEntity().codeName?lower_case}'].split(',') : [];
                data.forEach((ele: any, index: number) => {
                    const tempContext = Util.deepCopy(context);
                    Object.assign(tempContext, { ${item.getPSAppDataEntity().codeName?lower_case}: srfkeys[index] });
                    promiseArray.push(curService['${item.getPSAppDEMethod().getCodeName()}'](tempContext, ele));
                })
            }
            let promise: any = Promise.all(promiseArray);
                    <#else>
            let promise: any = curService['${item.getPSAppDEMethod().getCodeName()}'](context, data);
                    </#if>
            promise.then(async (response: any) => {
                    <#if item.getActionTarget() == 'SINGLEDATA'>
                Util.clearAdditionalData(tempData, args[0]);
                    </#if>
                if ((!response || response.status !== 200) && !Array.isArray(response)) {
                    actionContext.$Notice.error({ title: '错误', desc: response.message });
                    return;
                }
                let { data } = response;
                if (Array.isArray(response) && response.length > 0) {
                    data = [];
                    response.forEach((item: any) => {
                        data.push(item.data);
                    })
                }
                    <#--  合并参数  -->
                    <#if item.getPSAppDEMethod().isCustomCode?? && item.getPSAppDEMethod().isCustomCode() && !(item.getPSAppDEMethod().getPSDEServiceAPIMethod?? && item.getPSAppDEMethod().getPSDEServiceAPIMethod()??)>
                if (args && args.length > 0 && Object.prototype.toString.call(data) === '[Object Object]') {
                    Object.assign(args[0], data);
                    actionContext.$forceUpdate();
                }
                    </#if>
                    <#if item.isShowBusyIndicator()>
                        <#if item.getSuccessMsg?? && item.getSuccessMsg()??>
                actionContext.$Notice.success({ title: '成功', desc: '${item.getSuccessMsg()}' });
                        <#else>
                actionContext.$Notice.success({ title: '成功', desc: '${item.getCaption()}成功！' });
                        </#if>
                    </#if>
                <#--  是否重新加载数据  -->
                    <#if item.isReloadData?? && item.isReloadData()>
                if (xData && xData.refresh && xData.refresh instanceof Function) {
                    xData.refresh(args);
                }
                    </#if>
                    <#-- 关闭编辑视图 -->
                    <#if item.isCloseEditView()>
                actionContext.closeView(null);
                    </#if>
                    <#if item.isReloadData?? && item.isReloadData() && item.getRefreshMode?? && item.getRefreshMode()?? && item.getRefreshMode() == 1>
                if (xData && xData.getControlType instanceof Function && xData.getControlType() == 'FORM') {
                    AppCenterService.notifyMessage({ name: "${item.getPSAppDataEntity().getCodeName()}", action: 'appRefresh', data: args });
                }
                    </#if>
                    <#--  后续界面行为  -->
                    <#if item.getNextPSUIAction?? && item.getNextPSUIAction()??>
                let { data: result } = response;
                if (response && Array.isArray(response) && response.length > 0) {
                    result = [];
                    response.forEach((item: any) => {
                        result.push(item.data);
                    })
                }
                let _args: any[] = [];
                if (Object.is(actionContext.$util.typeOf(result), 'array')) {
                    _args = [...result];
                } else if (Object.is(actionContext.$util.typeOf(result), 'object')) {
                    _args = result && Object.keys(result).length > 0 ? [{ ...result }] : Util.deepCopy(args);
                } else {
                    _args = Util.deepCopy(args);
                }
                            <#if !(nextPSUIAction.getPSAppDataEntity?? && nextPSUIAction.getPSAppDataEntity()??)>
                if (_this.${nextPSUIAction.getFullCodeName()} && _this.${nextPSUIAction.getFullCodeName()} instanceof Function) {
                    _this.${nextPSUIAction.getFullCodeName()}(_args, context, params, $event, xData, actionContext);
                }
                            <#else>
                if (this.${nextPSUIAction.getFullCodeName()} && this.${nextPSUIAction.getFullCodeName()} instanceof Function) {
                    this.${nextPSUIAction.getFullCodeName()}(_args, context, params, $event, xData, actionContext);
                }
                            </#if>
                    <#else>
                        <#if item.getUILogicAttachMode?? && item.getUILogicAttachMode()?? && item.getUILogicAttachMode() == 'AFTER' && item.getPSAppDEUILogic?? && item.getPSAppDEUILogic()??>
                const _context: any = Object.assign(context, actionContext.context);
                const _params: any = Object.assign(params, actionContext.viewparams);
                            <#if item.getPSAppDataEntity?? && item.getPSAppDataEntity()?? && item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()?? && item.getPSAppDataEntity().codeName == item.getPSAppDEUILogic().getPSAppDataEntity().codeName>
                return this.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
                            <#elseif item.getPSAppDEUILogic().getPSAppDataEntity?? && item.getPSAppDEUILogic().getPSAppDataEntity()??>
                const uiService = await window.uiServiceRegister.getService('${item.getPSAppDEUILogic().getPSAppDataEntity().codeName?lower_case}');
                if (uiService) {
                    return uiService.executeUILogic('${item.getPSAppDEUILogic().codeName}', args, _context, _params, $event, xData, actionContext, srfParentDeName);
                }
                            </#if>
                        </#if>
                    </#if>
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    actionContext.$Notice.error({ title: (actionContext.$t('app.commonWords.wrong') as string), desc: response.data.message });
                    return;
                }
                if (!response || !response.status || !response.data) {
                    actionContext.$Notice.error({ title: (actionContext.$t('app.commonWords.wrong') as string), desc: (actionContext.$t('app.commonWords.sysException') as string) });
                    return;
                }
                return response;
            });
                <#else>
            actionContext.$Notice.error({ title: '错误', desc: '模型异常，应用实体方法不存在' });
                </#if>
        };
                <#if item.getFrontPSAppView()??>
                    <#assign frontview = item.getFrontPSAppView()>
                    <#--  抽屉打开  -->
                    <#if frontview.getOpenMode()?index_of('DRAWER') == 0>
        const view: any = {
            viewname: '${srffilepath2(frontview.getCodeName())}',
            title: actionContext.<@getViewLanguageTitle frontview />,
            height: ${frontview.getHeight()?c},
            width: ${frontview.getWidth()?c},
            placement: '${frontview.getOpenMode()}'
        };
        const appdrawer = actionContext.$appdrawer.openDrawer(view,context,data);
        appdrawer.subscribe((result: any) => {
            if (result && Object.is(result.ret, 'OK')) {
                if(data && data instanceof Array && data.length > 0){
                    data.forEach((item:any) => {
                        Object.assign(item, { srfactionparam: result.datas });
                    })
                } else {
                    Object.assign(data, { srfactionparam: result.datas });
                }
                backend();
            }
        });
        <#--  模态打开  -->
                    <#else>
        const view = { 
            viewname: '${srffilepath2(frontview.getCodeName())}', 
            title: actionContext.<@getViewLanguageTitle frontview />,
            height: ${frontview.getHeight()?c}, 
            width: ${frontview.getWidth()?c}, 
        };
        const appmodal = actionContext.$appmodal.openModal(view,context,data);
        appmodal.subscribe((result:any) => {
            if (result && Object.is(result.ret, 'OK')) {
                if(data && data instanceof Array && data.length > 0){
                    data.forEach((item:any) =>{
                        Object.assign(item, { srfactionparam: result.datas });
                    })
                } else {
                    Object.assign(data, { srfactionparam: result.datas });
                }
                backend();
            }
        });
                    </#if>
                <#else>
        backend();
                </#if>
            </#if>
        </#if>
    </#if>
    }
</#if>